GRPC Core 0.10.0.0

- Main Page
- Data Structures
- Files

- File List
- Globals

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
Data Structures | Macros | Typedefs | Functions
metadata.c File Reference
`#include "src/core/iomgr/sockaddr.h"`
`#include "src/core/transport/metadata.h"`
`#include <assert.h>`
`#include <stddef.h>`
`#include <string.h>`
`#include <grpc/support/alloc.h>`
`#include <grpc/support/atm.h>`
`#include <grpc/support/log.h>`
`#include "src/core/support/murmur_hash.h"`
`#include "src/core/transport/chttp2/bin_encoder.h"`
`#include <grpc/support/time.h>`

## Data Structures
struct | internal_string
struct | internal_metadata
struct | grpc_mdctx

## Macros
#define | INITIAL_STRTAB_CAPACITY 4
#define | INITIAL_MDTAB_CAPACITY 4
#define | DEBUG_ARGS
#define | FWD_DEBUG_ARGS
#define | INTERNAL_STRING_REF(s) internal_string_ref((s))
#define | INTERNAL_STRING_UNREF(s) internal_string_unref((s))
#define | REF_MD_LOCKED(s) ref_md_locked((s))

## Typedefs
typedef struct internal_string | internal_string
typedef struct internal_metadata | internal_metadata

## Functions
grpc_mdctx * | grpc_mdctx_create_with_seed (gpr_uint32 seed)
grpc_mdctx * | grpc_mdctx_create (void)
void | grpc_mdctx_ref (grpc_mdctx *ctx)
void | grpc_mdctx_unref (grpc_mdctx *ctx)
grpc_mdstr * | grpc_mdstr_from_string (grpc_mdctx *ctx, const char *str, int canonicalize_key)
grpc_mdstr * | grpc_mdstr_from_slice (grpc_mdctx *ctx, gpr_slice slice)
grpc_mdstr * | grpc_mdstr_from_buffer (grpc_mdctx *ctx, const gpr_uint8 *buf, size_t length)
grpc_mdelem * | grpc_mdelem_from_metadata_strings (grpc_mdctx *ctx, grpc_mdstr *mkey, grpc_mdstr *mvalue)
grpc_mdelem * | grpc_mdelem_from_strings (grpc_mdctx *ctx, const char *key, const char *value)
grpc_mdelem * | grpc_mdelem_from_slices (grpc_mdctx *ctx, gpr_slice key, gpr_slice value)
grpc_mdelem * | grpc_mdelem_from_string_and_buffer (grpc_mdctx *ctx, const char *key, const gpr_uint8 *value, size_t value_length, int canonicalize_key)
grpc_mdelem * | grpc_mdelem_ref (grpc_mdelem *gmd)
void | grpc_mdelem_unref (grpc_mdelem *gmd)
const char * | grpc_mdstr_as_c_string (grpc_mdstr *s)
grpc_mdstr * | grpc_mdstr_ref (grpc_mdstr *gs)
void | grpc_mdstr_unref (grpc_mdstr *gs)
size_t | grpc_mdctx_get_mdtab_capacity_test_only (grpc_mdctx *ctx)
size_t | grpc_mdctx_get_mdtab_count_test_only (grpc_mdctx *ctx)
size_t | grpc_mdctx_get_mdtab_free_test_only (grpc_mdctx *ctx)
void * | grpc_mdelem_get_user_data (grpc_mdelem *md, void(*if_destroy_func)(void *))
void | grpc_mdelem_set_user_data (grpc_mdelem *md, void(*destroy_func)(void *), void *user_data)
gpr_slice | grpc_mdstr_as_base64_encoded_and_huffman_compressed (grpc_mdstr *gs)
void | grpc_mdctx_lock (grpc_mdctx *ctx)
void | grpc_mdctx_locked_mdelem_unref (grpc_mdctx *ctx, grpc_mdelem *gmd)
void | grpc_mdctx_unlock (grpc_mdctx *ctx)
int | grpc_mdstr_is_legal_header (grpc_mdstr *s)
int | grpc_mdstr_is_bin_suffixed (grpc_mdstr *s)

## Macro Definition Documentation

#define DEBUG_ARGS

#define FWD_DEBUG_ARGS

#define INITIAL_MDTAB_CAPACITY 4

#define INITIAL_STRTAB_CAPACITY 4

#define INTERNAL_STRING_REF | ( |  | s | ) | internal_string_ref((s))

#define INTERNAL_STRING_UNREF | ( |  | s | ) | internal_string_unref((s))

#define REF_MD_LOCKED | ( |  | s | ) | ref_md_locked((s))

## Typedef Documentation

typedef struct internal_metadata internal_metadata

typedef struct internal_string internal_string

## Function Documentation

grpc_mdctx* grpc_mdctx_create | ( | void |  | ) |

grpc_mdctx* grpc_mdctx_create_with_seed | ( | gpr_uint32 | seed | ) |

size_t grpc_mdctx_get_mdtab_capacity_test_only | ( | grpc_mdctx * | ctx | ) |

size_t grpc_mdctx_get_mdtab_count_test_only | ( | grpc_mdctx * | ctx | ) |

size_t grpc_mdctx_get_mdtab_free_test_only | ( | grpc_mdctx * | ctx | ) |

void grpc_mdctx_lock | ( | grpc_mdctx * | ctx | ) |

void grpc_mdctx_locked_mdelem_unref | ( | grpc_mdctx * | ctx,
|  | grpc_mdelem * | gmd
| ) |  |

void grpc_mdctx_ref | ( | grpc_mdctx * | ctx | ) |

void grpc_mdctx_unlock | ( | grpc_mdctx * | ctx | ) |

void grpc_mdctx_unref | ( | grpc_mdctx * | ctx | ) |

grpc_mdelem* grpc_mdelem_from_metadata_strings | ( | grpc_mdctx * | ctx,
|  | grpc_mdstr * | mkey,
|  | grpc_mdstr * | mvalue
| ) |  |

grpc_mdelem* grpc_mdelem_from_slices | ( | grpc_mdctx * | ctx,
|  | gpr_slice | key,
|  | gpr_slice | value
| ) |  |

grpc_mdelem* grpc_mdelem_from_string_and_buffer | ( | grpc_mdctx * | ctx,
|  | const char * | key,
|  | const gpr_uint8 * | value,
|  | size_t | value_length,
|  | int | canonicalize_key
| ) |  |

grpc_mdelem* grpc_mdelem_from_strings | ( | grpc_mdctx * | ctx,
|  | const char * | key,
|  | const char * | value
| ) |  |

void* grpc_mdelem_get_user_data | ( | grpc_mdelem * | md,
|  | void(*)(void *) | if_destroy_func
| ) |  |

grpc_mdelem* grpc_mdelem_ref | ( | grpc_mdelem * | gmd | ) |

void grpc_mdelem_set_user_data | ( | grpc_mdelem * | md,
|  | void(*)(void *) | destroy_func,
|  | void * | user_data
| ) |  |

void grpc_mdelem_unref | ( | grpc_mdelem * | gmd | ) |

gpr_slice grpc_mdstr_as_base64_encoded_and_huffman_compressed | ( | grpc_mdstr * | gs | ) |

const char* grpc_mdstr_as_c_string | ( | grpc_mdstr * | s | ) |

grpc_mdstr* grpc_mdstr_from_buffer | ( | grpc_mdctx * | ctx,
|  | const gpr_uint8 * | buf,
|  | size_t | length
| ) |  |

grpc_mdstr* grpc_mdstr_from_slice | ( | grpc_mdctx * | ctx,
|  | gpr_slice | slice
| ) |  |

grpc_mdstr* grpc_mdstr_from_string | ( | grpc_mdctx * | ctx,
|  | const char * | str,
|  | int | canonicalize_key
| ) |  |

int grpc_mdstr_is_bin_suffixed | ( | grpc_mdstr * | s | ) |

int grpc_mdstr_is_legal_header | ( | grpc_mdstr * | s | ) |

grpc_mdstr* grpc_mdstr_ref | ( | grpc_mdstr * | gs | ) |

void grpc_mdstr_unref | ( | grpc_mdstr * | gs | ) |